import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class AppleTree  extends World
{

    private Joyce joyce = null;
    private CountdownClock countdownclock = null;
    Counter counter = new Counter("Number of Apples in Basket: ");
    
    public AppleTree()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(60, 70, 10); 
        joyce = new Joyce ();
        addObject (joyce, 5, 60);

        //Add the Countdown Clock. 
        countdownclock = new CountdownClock ();
        addObject (countdownclock, 56, 1);
        countdownclock.updateDisplay("60");

/**
 * Setting the order that actors will appear if they overlap each other.
 */        
        setPaintOrder(ScoreBoard1.class, ScoreBoard2.class, Joyce.class, Worm.class, Apple.class, CountdownClock.class, Counter.class);
        addCounter();
        
    }

    /**
     * Calling the droppingApples and droppingWorms methods.
     * Stopping the game when Countdown Clock is 0 and adding the different scoreboards appropriately according to the score on the Counter.
     */    
    public void act ()
    {
        droppingApples();
        droppingWorms();
        ScoreBoard1 scoreboard1 = new ScoreBoard1(Counter.target);
        ScoreBoard2 scoreboard2 = new ScoreBoard2(Counter.target);
        if(CountdownClock.counter <= 0 && Counter.target < 30)
        {
            addObject(scoreboard2, getWidth()/2, getHeight()/2);
            Greenfoot.stop();
        }
        if(CountdownClock.counter <= 0 && Counter.target >= 30)
        {
            addObject(scoreboard1, getWidth()/2, getHeight()/2);
            Greenfoot.stop();
        }
               
   
            
    }
    
/**
 * Adding Apples to the World randomly.
 */    
    
    public void droppingApples ()
    {
        if(Greenfoot.getRandomNumber (100)<3)
            {addObject (new Apple (), Greenfoot.getRandomNumber(70), 0);
            }
    }

/**
 * Adding Worms to the World randomly.
 */   
    
     public void droppingWorms ()
    {
        if(Greenfoot.getRandomNumber (100)<2)
            {addObject (new Worm (), Greenfoot.getRandomNumber(70), 0);
            }
    }

/**
 * Adding the Counter to the top left of the World.
 */    
    
    private void addCounter()
    {
        addObject(counter, 24, 1);
        counter.updateImage();
    }
    

}
